package user

import (
	"duoduo/models/mysql"
	"duoduo/models/user"
	"duoduo/tools/app"
	"github.com/gin-gonic/gin"
)

func OrderGet(c *gin.Context) {
	var inData user.OrderGetRequest
	//var outData user.OrderGetResponse
	//var order []mysql.Order
	var orderOpneId mysql.Order
	var pid mysql.Pid

	var pageSize = 10
	var pageIndex = 1

	err := c.ShouldBindJSON(&inData)
	if err != nil {
		app.Error(c, 400, err, err.Error())
		return
	}

	if inData.PageSize != 0 {
		pageSize = inData.PageSize
	}
	if inData.PageIndex != 0 {
		pageIndex = inData.PageIndex
	}

	pid.OpenID = inData.OpenId
	pid.PidStatus = 1
	pidVal, err := pid.Get()
	if err != nil {
		app.Error(c, 500, err, err.Error())
		return
	}

	orderOpneId.PID = pidVal.Pid
	orderVal, count, err := orderOpneId.GetOrderList(pageSize, pageIndex)
	if err != nil {
		app.Error(c, 500, err, err.Error())
		return
	}

	app.PageOK(c, orderVal, count, pageIndex, pageSize, app.Success)
}
